Index: trunk/lib/FlairCore/src/IODevice_impl.cpp
===================================================================
--- trunk/lib/FlairCore/src/IODevice_impl.cpp	(revision 14)
+++ trunk/lib/FlairCore/src/IODevice_impl.cpp	(revision 15)
@@ -31,12 +31,12 @@
 using namespace flair::core;
 
-IODevice_impl::IODevice_impl(const IODevice* self) {
-    this->self=self;
-    thread_to_wake=NULL;
-    wake_mutex= new Mutex(self);
-    framework_impl=::getFrameworkManagerImpl();
-    framework=getFrameworkManager();
-    tobelogged=false;
-    outputtoshm=false;
+IODevice_impl::IODevice_impl(const IODevice *self) {
+  this->self = self;
+  thread_to_wake = NULL;
+  wake_mutex = new Mutex(self);
+  framework_impl = ::getFrameworkManagerImpl();
+  framework = getFrameworkManager();
+  tobelogged = false;
+  outputtoshm = false;
 }
 
@@ -44,176 +44,187 @@
 
 void IODevice_impl::OutputToShMem(bool enabled) {
-    if(framework->IsLogging()) {
-        self->Err("impossible while logging\n");
+  if (framework->IsLogging()) {
+    self->Err("impossible while logging\n");
+  } else {
+    if (LogSize() == 0) {
+      self->Warn("log size is null, not enabling output to shared memory.");
+      return;
+    }
+
+    if (enabled) {
+      string dev_name =
+          getFrameworkManager()->ObjectName() + "-" + self->ObjectName();
+      shmem = new SharedMem(self, dev_name.c_str(), LogSize());
+      outputtoshm = true;
+
+      Printf("Created %s shared memory for object %s; size: %i\n",
+             dev_name.c_str(), self->ObjectName().c_str(), LogSize());
+      PrintLogsDescriptors();
     } else {
-        if(LogSize()==0) {
-            self->Warn("log size is null, not enabling output to shared memory.");
-            return;
-        }
-
-        if(enabled) {
-            string dev_name=getFrameworkManager()->ObjectName()+ "-" + self->ObjectName();
-            shmem=new SharedMem(self,dev_name.c_str(),LogSize());
-            outputtoshm=true;
-
-            Printf("Created %s shared memory for object %s; size: %i\n",dev_name.c_str(),self->ObjectName().c_str(),LogSize());
-            PrintLogsDescriptors();
-        } else {
-            outputtoshm=false;
-            delete shmem;
-        }
+      outputtoshm = false;
+      delete shmem;
     }
+  }
 }
 
 void IODevice_impl::PrintLogsDescriptors(void) {
-    //own logs
-    for(size_t i=0;i<datasToLog.size();i++) datasToLog.at(i)->pimpl_->PrintLogDescriptor();
-    //childs logs
-    for(size_t i=0;i<self->TypeChilds()->size();i++) ((IODevice*)self->TypeChilds()->at(i))->pimpl_->PrintLogsDescriptors();
-    //manually added logs
-    for(size_t i=0;i<devicesToLog.size();i++) devicesToLog.at(i)->pimpl_->PrintLogsDescriptors();
+  // own logs
+  for (size_t i = 0; i < datasToLog.size(); i++)
+    datasToLog.at(i)->pimpl_->PrintLogDescriptor();
+  // childs logs
+  for (size_t i = 0; i < self->TypeChilds()->size(); i++)
+    ((IODevice *)self->TypeChilds()->at(i))->pimpl_->PrintLogsDescriptors();
+  // manually added logs
+  for (size_t i = 0; i < devicesToLog.size(); i++)
+    devicesToLog.at(i)->pimpl_->PrintLogsDescriptors();
 }
 
 void IODevice_impl::WriteToShMem(void) {
-    if(outputtoshm) {
-        size_t size=LogSize();
-
-        char* buf=framework_impl->GetBuffer(size);
-        char* buf_orig=buf;
-        if(buf==NULL) {
-            self->Err("err GetBuffer\n");
-            return;
-        }
-
-        AppendLog(&buf);
-
-        shmem->Write(buf_orig,size);
-        framework_impl->ReleaseBuffer(buf_orig);
+  if (outputtoshm) {
+    size_t size = LogSize();
+
+    char *buf = framework_impl->GetBuffer(size);
+    char *buf_orig = buf;
+    if (buf == NULL) {
+      self->Err("err GetBuffer\n");
+      return;
     }
-}
-
-void IODevice_impl::AddDeviceToLog(const IODevice* device) {
-    if(framework->IsLogging()) {
-        self->Err("impossible while logging\n");
-    } else {
-        devicesToLog.push_back(device);
-    }
+
+    AppendLog(&buf);
+
+    shmem->Write(buf_orig, size);
+    framework_impl->ReleaseBuffer(buf_orig);
+  }
+}
+
+void IODevice_impl::AddDeviceToLog(const IODevice *device) {
+  if (framework->IsLogging()) {
+    self->Err("impossible while logging\n");
+  } else {
+    devicesToLog.push_back(device);
+  }
 }
 
 bool IODevice_impl::SetToBeLogged(void) {
-    if(!tobelogged) {
-        tobelogged=true;
-        return true;
-    } else {
-        self->Warn("already added to log\n");
-        return false;
-    }
-}
-
-void IODevice_impl::WriteLogsDescriptors(fstream& desc_file,int *index) {
-    //own descriptor
-    for(size_t i=0;i<datasToLog.size();i++) datasToLog.at(i)->pimpl_->WriteLogDescriptor(desc_file,index);
-    //childs descriptors
-    for(size_t i=0;i<self->TypeChilds()->size();i++) ((IODevice*)self->TypeChilds()->at(i))->pimpl_->WriteLogsDescriptors(desc_file,index);
-    //manually added logs
-    for(size_t i=0;i<devicesToLog.size();i++) devicesToLog.at(i)->pimpl_->WriteLogsDescriptors(desc_file,index);
+  if (!tobelogged) {
+    tobelogged = true;
+    return true;
+  } else {
+    self->Warn("already added to log\n");
+    return false;
+  }
+}
+
+void IODevice_impl::WriteLogsDescriptors(fstream &desc_file, int *index) {
+  // own descriptor
+  for (size_t i = 0; i < datasToLog.size(); i++)
+    datasToLog.at(i)->pimpl_->WriteLogDescriptor(desc_file, index);
+  // childs descriptors
+  for (size_t i = 0; i < self->TypeChilds()->size(); i++)
+    ((IODevice *)self->TypeChilds()->at(i))
+        ->pimpl_->WriteLogsDescriptors(desc_file, index);
+  // manually added logs
+  for (size_t i = 0; i < devicesToLog.size(); i++)
+    devicesToLog.at(i)->pimpl_->WriteLogsDescriptors(desc_file, index);
 }
 
 void IODevice_impl::ResumeThread(void) {
-    wake_mutex->GetMutex();
-    if(thread_to_wake!=NULL) {
-        thread_to_wake->Resume();
-        thread_to_wake=NULL;
-    }
-    wake_mutex->ReleaseMutex();
-}
-
-void IODevice_impl::AddDataToLog(const io_data* data) {
-    if(framework->IsLogging()) {
-        self->Err("impossible while logging\n");
-    } else {
-        datasToLog.push_back(data);
-    }
+  wake_mutex->GetMutex();
+  if (thread_to_wake != NULL) {
+    thread_to_wake->Resume();
+    thread_to_wake = NULL;
+  }
+  wake_mutex->ReleaseMutex();
+}
+
+void IODevice_impl::AddDataToLog(const io_data *data) {
+  if (framework->IsLogging()) {
+    self->Err("impossible while logging\n");
+  } else {
+    datasToLog.push_back(data);
+  }
 }
 
 size_t IODevice_impl::LogSize() const {
-    size_t value=0;
-
-    for(size_t i=0;i<datasToLog.size();i++) {
-        value+=datasToLog.at(i)->GetDataType().GetSize();
-    }
-
-    //childs logs
-    for(size_t i=0;i<self->TypeChilds()->size();i++) {
-        value+=((IODevice*)self->TypeChilds()->at(i))->pimpl_->LogSize();
-    }
-    //manually added logs
-    for(size_t i=0;i<devicesToLog.size();i++) {
-        value+=devicesToLog.at(i)->pimpl_->LogSize();
-    }
-
-    return value;
+  size_t value = 0;
+
+  for (size_t i = 0; i < datasToLog.size(); i++) {
+    value += datasToLog.at(i)->GetDataType().GetSize();
+  }
+
+  // childs logs
+  for (size_t i = 0; i < self->TypeChilds()->size(); i++) {
+    value += ((IODevice *)self->TypeChilds()->at(i))->pimpl_->LogSize();
+  }
+  // manually added logs
+  for (size_t i = 0; i < devicesToLog.size(); i++) {
+    value += devicesToLog.at(i)->pimpl_->LogSize();
+  }
+
+  return value;
 }
 
 void IODevice_impl::WriteLog(Time time) {
-    if(tobelogged==false) return;
-
-    size_t size=LogSize();
-
-    char* buf=framework_impl->GetBuffer(sizeof(FrameworkManager_impl::log_header_t)+size);
-    char* buf_orig=buf;
-    if(buf==NULL) {
-        self->Err("err GetBuffer\n");
-        return;
-    }
-
-    FrameworkManager_impl::log_header_t header;
-    header.device=self;
-    header.size=size;
-    header.time=time;
-
-    memcpy(buf,&header,sizeof(FrameworkManager_impl::log_header_t));
-    buf+=sizeof(FrameworkManager_impl::log_header_t);
-    AppendLog(&buf);
-
-    framework_impl->WriteLog(buf_orig,sizeof(FrameworkManager_impl::log_header_t)+size);
-    framework_impl->ReleaseBuffer(buf_orig);
-}
-
-void IODevice_impl::AppendLog(char** ptr)
-{
-    //Printf("AppendLog %s %x\n",self->ObjectName().c_str(),*ptr);
-
-    //copy state to buf
-    for(size_t i=0;i<datasToLog.size();i++) {
-        //printf("copy\n");
-        datasToLog.at(i)->CopyDatas(*ptr);
-        (*ptr)+=datasToLog.at(i)->GetDataType().GetSize();
-    }
-
-    //copy linked states to buf
-    for(size_t i=0;i<self->TypeChilds()->size();i++) {
-        ((IODevice*)self->TypeChilds()->at(i))->pimpl_->AppendLog(ptr);
-    }
-    //copy manually added logs to buf
-    for(size_t i=0;i<devicesToLog.size();i++) {
-        devicesToLog.at(i)->pimpl_->AppendLog(ptr);
-        //devices.at(i)->DataToLog()->CopyDatas(*ptr);
-        //(*ptr)+=devices.at(i)->DataToLog()->Size();
-    }
-    //Printf("AppendLog %s ok\n",self->ObjectName().c_str());
-}
-
-int IODevice_impl::SetToWake(const Thread* thread) {
-    int status=0;
-
-    wake_mutex->GetMutex();
-    if(thread_to_wake==NULL) {
-        thread_to_wake=(Thread*)thread;
-    } else {
-        status=-1;
-    }
-    wake_mutex->ReleaseMutex();
-
-    return status;
-}
+  if (tobelogged == false)
+    return;
+
+  size_t size = LogSize();
+
+  char *buf = framework_impl->GetBuffer(
+      sizeof(FrameworkManager_impl::log_header_t) + size);
+  char *buf_orig = buf;
+  if (buf == NULL) {
+    self->Err("err GetBuffer\n");
+    return;
+  }
+
+  FrameworkManager_impl::log_header_t header;
+  header.device = self;
+  header.size = size;
+  header.time = time;
+
+  memcpy(buf, &header, sizeof(FrameworkManager_impl::log_header_t));
+  buf += sizeof(FrameworkManager_impl::log_header_t);
+  AppendLog(&buf);
+
+  framework_impl->WriteLog(buf_orig,
+                           sizeof(FrameworkManager_impl::log_header_t) + size);
+  framework_impl->ReleaseBuffer(buf_orig);
+}
+
+void IODevice_impl::AppendLog(char **ptr) {
+  // Printf("AppendLog %s %x\n",self->ObjectName().c_str(),*ptr);
+
+  // copy state to buf
+  for (size_t i = 0; i < datasToLog.size(); i++) {
+    // printf("copy\n");
+    datasToLog.at(i)->CopyDatas(*ptr);
+    (*ptr) += datasToLog.at(i)->GetDataType().GetSize();
+  }
+
+  // copy linked states to buf
+  for (size_t i = 0; i < self->TypeChilds()->size(); i++) {
+    ((IODevice *)self->TypeChilds()->at(i))->pimpl_->AppendLog(ptr);
+  }
+  // copy manually added logs to buf
+  for (size_t i = 0; i < devicesToLog.size(); i++) {
+    devicesToLog.at(i)->pimpl_->AppendLog(ptr);
+    // devices.at(i)->DataToLog()->CopyDatas(*ptr);
+    //(*ptr)+=devices.at(i)->DataToLog()->Size();
+  }
+  // Printf("AppendLog %s ok\n",self->ObjectName().c_str());
+}
+
+int IODevice_impl::SetToWake(const Thread *thread) {
+  int status = 0;
+
+  wake_mutex->GetMutex();
+  if (thread_to_wake == NULL) {
+    thread_to_wake = (Thread *)thread;
+  } else {
+    status = -1;
+  }
+  wake_mutex->ReleaseMutex();
+
+  return status;
+}
Index: trunk/lib/FlairCore/src/ImuData.cpp
===================================================================
--- trunk/lib/FlairCore/src/ImuData.cpp	(revision 14)
+++ trunk/lib/FlairCore/src/ImuData.cpp	(revision 15)
@@ -24,225 +24,227 @@
 using std::string;
 
-namespace flair { namespace core {
+namespace flair {
+namespace core {
 
 /*! \class ImuDataElement
     */
-    class ImuDataElement: public IODataElement {
-        public:
-
-            ImuDataElement(const ImuData *inImudata,string name,ImuData::PlotableData_t inPlotableData):IODataElement(inImudata,name) {
-                imudata=inImudata;
-                plotableData=inPlotableData;
-
-                size=4;
-            }
-
-            ~ImuDataElement() {}
-
-            void CopyData(char* dst) const {
-                float data;
-                Vector3D rawAcc=imudata->GetRawAcc();
-                Vector3D rawMag=imudata->GetRawMag();
-                Vector3D rawGyr=imudata->GetRawGyr();
-                switch(plotableData) {
-                case ImuData::RawAx:
-                    data=rawAcc.x;
-                    break;
-                case ImuData::RawAy:
-                    data=rawAcc.y;
-                    break;
-                case ImuData::RawAz:
-                    data=rawAcc.z;
-                    break;
-                case ImuData::RawGx:
-                    data=rawGyr.x;
-                    break;
-                case ImuData::RawGy:
-                    data=rawGyr.y;
-                    break;
-                case ImuData::RawGz:
-                    data=rawGyr.z;
-                    break;
-                case ImuData::RawGxDeg:
-                    data=Euler::ToDegree(rawGyr.x);
-                    break;
-                case ImuData::RawGyDeg:
-                    data=Euler::ToDegree(rawGyr.y);
-                    break;
-                case ImuData::RawGzDeg:
-                    data=Euler::ToDegree(rawGyr.z);
-                    break;
-                case ImuData::RawMx:
-                    data=rawMag.x;
-                    break;
-                case ImuData::RawMy:
-                    data=rawMag.y;
-                    break;
-                case ImuData::RawMz:
-                    data=rawMag.z;
-                    break;
-                default:
-                    imudata->Err("data type unavailable.\n");
-                    data=0;
-                    break;
-                }
-
-                memcpy(dst,&data,sizeof(float));
-            }
-
-            FloatType const &GetDataType(void) const {
-                return dataType;
-            }
-
-        private:
-            const ImuData *imudata;
-            ImuData::PlotableData_t plotableData;
-            FloatType dataType;
-
-    };
-
-ImuData::ImuData(const Object* parent,std::string name,int n): io_data(parent,name,n),dataType(floatType) {
-    if(n>1) Warn("n>1 not supported\n");
-
-    AppendLogDescription("raw_ax",floatType);
-    AppendLogDescription("raw_ay",floatType);
-    AppendLogDescription("raw_az",floatType);
-
-    AppendLogDescription("raw_gx",floatType);
-    AppendLogDescription("raw_gy",floatType);
-    AppendLogDescription("raw_gz",floatType);
-
-    AppendLogDescription("raw_mx",floatType);
-    AppendLogDescription("raw_my",floatType);
-    AppendLogDescription("raw_mz",floatType);
-
+class ImuDataElement : public IODataElement {
+public:
+  ImuDataElement(const ImuData *inImudata, string name,
+                 ImuData::PlotableData_t inPlotableData)
+      : IODataElement(inImudata, name) {
+    imudata = inImudata;
+    plotableData = inPlotableData;
+
+    size = 4;
+  }
+
+  ~ImuDataElement() {}
+
+  void CopyData(char *dst) const {
+    float data;
+    Vector3D rawAcc = imudata->GetRawAcc();
+    Vector3D rawMag = imudata->GetRawMag();
+    Vector3D rawGyr = imudata->GetRawGyr();
+    switch (plotableData) {
+    case ImuData::RawAx:
+      data = rawAcc.x;
+      break;
+    case ImuData::RawAy:
+      data = rawAcc.y;
+      break;
+    case ImuData::RawAz:
+      data = rawAcc.z;
+      break;
+    case ImuData::RawGx:
+      data = rawGyr.x;
+      break;
+    case ImuData::RawGy:
+      data = rawGyr.y;
+      break;
+    case ImuData::RawGz:
+      data = rawGyr.z;
+      break;
+    case ImuData::RawGxDeg:
+      data = Euler::ToDegree(rawGyr.x);
+      break;
+    case ImuData::RawGyDeg:
+      data = Euler::ToDegree(rawGyr.y);
+      break;
+    case ImuData::RawGzDeg:
+      data = Euler::ToDegree(rawGyr.z);
+      break;
+    case ImuData::RawMx:
+      data = rawMag.x;
+      break;
+    case ImuData::RawMy:
+      data = rawMag.y;
+      break;
+    case ImuData::RawMz:
+      data = rawMag.z;
+      break;
+    default:
+      imudata->Err("data type unavailable.\n");
+      data = 0;
+      break;
+    }
+
+    memcpy(dst, &data, sizeof(float));
+  }
+
+  FloatType const &GetDataType(void) const { return dataType; }
+
+private:
+  const ImuData *imudata;
+  ImuData::PlotableData_t plotableData;
+  FloatType dataType;
+};
+
+ImuData::ImuData(const Object *parent, std::string name, int n)
+    : io_data(parent, name, n), dataType(floatType) {
+  if (n > 1)
+    Warn("n>1 not supported\n");
+
+  AppendLogDescription("raw_ax", floatType);
+  AppendLogDescription("raw_ay", floatType);
+  AppendLogDescription("raw_az", floatType);
+
+  AppendLogDescription("raw_gx", floatType);
+  AppendLogDescription("raw_gy", floatType);
+  AppendLogDescription("raw_gz", floatType);
+
+  AppendLogDescription("raw_mx", floatType);
+  AppendLogDescription("raw_my", floatType);
+  AppendLogDescription("raw_mz", floatType);
 }
 
 ImuData::~ImuData() {}
 
-
 Vector3D ImuData::GetRawAcc(void) const {
-    Vector3D out;
-    GetMutex();
-    out=rawAcc;
-    ReleaseMutex();
-    return out;
+  Vector3D out;
+  GetMutex();
+  out = rawAcc;
+  ReleaseMutex();
+  return out;
 }
 
 Vector3D ImuData::GetRawMag(void) const {
-    Vector3D out;
-    GetMutex();
-    out=rawMag;
-    ReleaseMutex();
-    return out;
+  Vector3D out;
+  GetMutex();
+  out = rawMag;
+  ReleaseMutex();
+  return out;
 }
 
 Vector3D ImuData::GetRawGyr(void) const {
-    Vector3D out;
-    GetMutex();
-    out=rawGyr;
-    ReleaseMutex();
-    return out;
-}
-
-void ImuData::GetRawAccMagAndGyr(Vector3D &inRawAcc,Vector3D &inRawMag,Vector3D &inRawGyr) const {
-    GetMutex();
-    inRawAcc=rawAcc;
-    inRawMag=rawMag;
-    inRawGyr=rawGyr;
-    ReleaseMutex();
+  Vector3D out;
+  GetMutex();
+  out = rawGyr;
+  ReleaseMutex();
+  return out;
+}
+
+void ImuData::GetRawAccMagAndGyr(Vector3D &inRawAcc, Vector3D &inRawMag,
+                                 Vector3D &inRawGyr) const {
+  GetMutex();
+  inRawAcc = rawAcc;
+  inRawMag = rawMag;
+  inRawGyr = rawGyr;
+  ReleaseMutex();
 }
 
 void ImuData::SetRawAcc(const Vector3D &inRawAcc) {
-    GetMutex();
-    rawAcc=inRawAcc;
-    ReleaseMutex();
+  GetMutex();
+  rawAcc = inRawAcc;
+  ReleaseMutex();
 }
 
 void ImuData::SetRawMag(const Vector3D &inRawMag) {
-    GetMutex();
-    rawMag=inRawMag;
-    ReleaseMutex();
+  GetMutex();
+  rawMag = inRawMag;
+  ReleaseMutex();
 }
 
 void ImuData::SetRawGyr(const Vector3D &inRawGyr) {
-    GetMutex();
-    rawGyr=inRawGyr;
-    ReleaseMutex();
-}
-
-void ImuData::SetRawAccMagAndGyr(const Vector3D &inRawAcc,const Vector3D &inRawMag,const Vector3D &inRawGyr) {
-    GetMutex();
-    rawAcc=inRawAcc;
-    rawMag=inRawMag;
-    rawGyr=inRawGyr;
-    ReleaseMutex();
-}
-
-IODataElement* ImuData::Element(PlotableData_t data_type) const {
-    string name;
-    switch(data_type) {
-    case ImuData::RawAx:
-        name="RawAx";
-        break;
-    case ImuData::RawAy:
-        name="RawAy";
-        break;
-    case ImuData::RawAz:
-        name="RawAz";
-        break;
-    case ImuData::RawGx:
-        name="RawGx";
-        break;
-    case ImuData::RawGy:
-        name="RawGy";
-        break;
-    case ImuData::RawGz:
-        name="RawGz";
-        break;
-    case ImuData::RawGxDeg:
-        name="RawGx degree";
-        break;
-    case ImuData::RawGyDeg:
-        name="RawGy degree";
-        break;
-    case ImuData::RawGzDeg:
-        name="RawGz degree";
-        break;
-    case ImuData::RawMx:
-        name="RawMx";
-        break;
-    case ImuData::RawMy:
-        name="RawMy";
-        break;
-    case ImuData::RawMz:
-        name="RawMz";
-        break;
-    }
-
-    return new ImuDataElement(this,name,data_type);
-}
-
-void ImuData::CopyDatas(char* dst) const {
-    GetMutex();
-
-    Queue(&dst,&rawAcc.x,sizeof(rawAcc.x));
-    Queue(&dst,&rawAcc.y,sizeof(rawAcc.y));
-    Queue(&dst,&rawAcc.z,sizeof(rawAcc.z));
-
-    Queue(&dst,&rawGyr.x,sizeof(rawGyr.x));
-    Queue(&dst,&rawGyr.y,sizeof(rawGyr.y));
-    Queue(&dst,&rawGyr.z,sizeof(rawGyr.z));
-
-    Queue(&dst,&rawMag.x,sizeof(rawMag.x));
-    Queue(&dst,&rawMag.y,sizeof(rawMag.y));
-    Queue(&dst,&rawMag.z,sizeof(rawMag.z));
-
-    ReleaseMutex();
-}
-
-void ImuData::Queue(char** dst,const void *src,size_t size) const {
-    memcpy(*dst,src,size);
-    *dst+=size;
+  GetMutex();
+  rawGyr = inRawGyr;
+  ReleaseMutex();
+}
+
+void ImuData::SetRawAccMagAndGyr(const Vector3D &inRawAcc,
+                                 const Vector3D &inRawMag,
+                                 const Vector3D &inRawGyr) {
+  GetMutex();
+  rawAcc = inRawAcc;
+  rawMag = inRawMag;
+  rawGyr = inRawGyr;
+  ReleaseMutex();
+}
+
+IODataElement *ImuData::Element(PlotableData_t data_type) const {
+  string name;
+  switch (data_type) {
+  case ImuData::RawAx:
+    name = "RawAx";
+    break;
+  case ImuData::RawAy:
+    name = "RawAy";
+    break;
+  case ImuData::RawAz:
+    name = "RawAz";
+    break;
+  case ImuData::RawGx:
+    name = "RawGx";
+    break;
+  case ImuData::RawGy:
+    name = "RawGy";
+    break;
+  case ImuData::RawGz:
+    name = "RawGz";
+    break;
+  case ImuData::RawGxDeg:
+    name = "RawGx degree";
+    break;
+  case ImuData::RawGyDeg:
+    name = "RawGy degree";
+    break;
+  case ImuData::RawGzDeg:
+    name = "RawGz degree";
+    break;
+  case ImuData::RawMx:
+    name = "RawMx";
+    break;
+  case ImuData::RawMy:
+    name = "RawMy";
+    break;
+  case ImuData::RawMz:
+    name = "RawMz";
+    break;
+  }
+
+  return new ImuDataElement(this, name, data_type);
+}
+
+void ImuData::CopyDatas(char *dst) const {
+  GetMutex();
+
+  Queue(&dst, &rawAcc.x, sizeof(rawAcc.x));
+  Queue(&dst, &rawAcc.y, sizeof(rawAcc.y));
+  Queue(&dst, &rawAcc.z, sizeof(rawAcc.z));
+
+  Queue(&dst, &rawGyr.x, sizeof(rawGyr.x));
+  Queue(&dst, &rawGyr.y, sizeof(rawGyr.y));
+  Queue(&dst, &rawGyr.z, sizeof(rawGyr.z));
+
+  Queue(&dst, &rawMag.x, sizeof(rawMag.x));
+  Queue(&dst, &rawMag.y, sizeof(rawMag.y));
+  Queue(&dst, &rawMag.z, sizeof(rawMag.z));
+
+  ReleaseMutex();
+}
+
+void ImuData::Queue(char **dst, const void *src, size_t size) const {
+  memcpy(*dst, src, size);
+  *dst += size;
 }
 
